Lua_ClimbTowerDailyRewardWindow = class("Lua_ClimbTowerDailyRewardWindow", Lua_Window);
function Lua_ClimbTowerDailyRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ClimbTowerDailyRewardWindow";
	self.skinName = "ClimbTowerDailyRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ClimbTowerDailyRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_ItemIconList.new(self.content)
	self.itemList:setLocation(0, 0, 0);
	self.itemList.canClick = true;

	self.btnFunc:addClickFuntion(self, self.onBtnFuncClick);
end

function Lua_ClimbTowerDailyRewardWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_ClimbTowerDailyRewardWindow:showWin(param)
	self:superCall("showWin", param);

	self.data = DataCenter.climbTowerData:getTowerVoById(param);
	local state = self.data.daily_gift_state;
	local list = self.data.daily_reward;
	if state == nil then
		self.btnFunc:setLangValue(201013);
	else
		if state.value == 1 then
			self.btnFunc:setLangValue(201012);
			if state.key <= 0 then
				self.promptText:setLangValue(201009);
				list = self.data.daily_reward;
			else
				local config = DataCenter.climbTowerUtil:getTowerConfig(state.key);
				self.promptText.text = LanUtil.formateStr(201010, tostring(config.storey));
				list = config.daily_reward;
			end
		elseif state.value == 2 then
			self.btnFunc:setLangValue(201013);
			if self.data.pass_times <= 0 then
				list = self.data.daily_reward;
				self.promptText:setLangValue(201008);
			else
				local id = self.data.cur_stage_storey - 1;
				if self.data.cur_stage_state == 1 then
					id = self.data.cur_stage_storey;
				end
				self.promptText.text = LanUtil.formateStr(201011, tostring(id));
				local config = DataCenter.climbTowerUtil:getTowerConfig(param * 10000 + id);
				list = config.daily_reward;
			end
		end
	end
	self.itemList:setArrayData(list);
end

function Lua_ClimbTowerDailyRewardWindow:onBtnFuncClick(go)
	local state = self.data.daily_gift_state;
	if state ~= nil and state.value == 1 then
		Lua_ProxyManager.getProxy("Lua_ClimbTowerProxy"):sReceiveDailyReward(self.showData);
	end
	self:hide();
end