-- 爬塔入口
Lua_ClimbTowerEntranceWindow = class("Lua_ClimbTowerEntranceWindow", Lua_Window);
function Lua_ClimbTowerEntranceWindow:ctor()
	self:superCall("ctor");
	
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_ClimbTowerEntranceWindow";
	self.skinName = "ClimbTowerEntranceWindow_skin";
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.showBackBtn = true;
	self.isFullPaving = true;
	self.winBgPath = "/images/climb_tower/ui_ttt_bj_001.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_ClimbTowerEntranceWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.redPointArr = Array();
	self.effectDic = {};

	self:addLuaEvent("UPDATE_TOWER_INFO", self, self.updateShowInfo);
	self:addLuaEvent("FIGHTPLAY_ENTER", self, self.checkIsFighting);
	self:addLuaEvent("FIGHTPLAY_COMPLETE", self, self.checkIsFighting);

	local arr = DataCenter.climbTowerData.towerArr;
	local vo;
	local redPoint;
	local posDic = {{320, 655}, {-55, 186}, {320, 422}, {-55, 422}, {320, 186}};
	for i = 1, arr:getSize() do
		vo = DataCenter.climbTowerData:getTowerVoById(arr[i]);
		self["mask_"..vo.id]:setEnable(not vo.isOpened);
		self["openText_"..vo.id]:setEnable(not vo.isOpened);
		self["openText_"..vo.id].text = vo.open_str;
		self["layerText_"..vo.id].text = LanUtil.formateStr(201000, tostring(vo.cur_storey));

		if vo.isOpened then
			if arr[i] == 9 then
				redPoint = Lua_RedPointIcon.new(self["towerObject_"..vo.id], "ClimbTower_9", "ClimbTower_9_Daily");
			else
				redPoint = Lua_RedPointIcon.new(self["towerObject_"..vo.id], "ClimbTower_"..vo.id, "ClimbTower_"..vo.id.."_Login");
			end
			redPoint:setRectAnchor(7);
			redPoint:setLocation(posDic[i][1], posDic[i][2], 0);
		end
		self.redPointArr:add(redPoint);

		self["tower_"..vo.id].clickScale = false;
		self["tower_"..vo.id]:addClickFuntion(self, self.onClick);
	end
	
	Lua_ProxyManager.getProxy("Lua_ClimbTowerProxy"):sTowerInfo(0);
end

function Lua_ClimbTowerEntranceWindow:onBackBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1047, true, false);
end

function Lua_ClimbTowerEntranceWindow:dispose()
	if self.redPointArr ~= nil then
		self.redPointArr:dispose();
		self.redPointArr:clear();
		self.redPointArr = nil;
	end
	if self.effectDic then
		for k,v in pairs(self.effectDic) do
			v:dispose();
			self.effectDic[k] = nil;
		end
	end
	self:superCall("dispose");
end

function Lua_ClimbTowerEntranceWindow:updateShowInfo(towerId)
	local vo = DataCenter.climbTowerData:getTowerVoById(towerId);
	self["mask_"..vo.id]:setEnable(not vo.isOpened);
	self["openText_"..vo.id]:setEnable(not vo.isOpened);
	self["openText_"..vo.id].text = vo.open_str;
	self["layerText_"..vo.id].text = LanUtil.formateStr(201000, tostring(vo.cur_storey));
	self:checkIsFighting(vo.fight_id);
end

function Lua_ClimbTowerEntranceWindow:checkIsFighting(templateId)
	local isFighting = DataCenter.fightData:checkFightingByTemplateId(templateId);
	local effect = self.effectDic[templateId];
	if isFighting == true then
		if effect == nil then
			if templateId == 1007 then
				effect = UICreate.createUIEffect(self.towerObject_1, "/effects/uiEffects/ui_ty_zdbs_0101", "ui_ty_zdbs_0101", -50, 564);
			elseif templateId == 1008 then
				effect = UICreate.createUIEffect(self.towerObject_2, "/effects/uiEffects/ui_ty_zdbs_0101", "ui_ty_zdbs_0101", 295, 564);
			elseif templateId == 1009 then
				effect = UICreate.createUIEffect(self.towerObject_3, "/effects/uiEffects/ui_ty_zdbs_0101", "ui_ty_zdbs_0101", -50, 332.5);
			elseif templateId == 1010 then
				effect = UICreate.createUIEffect(self.towerObject_4, "/effects/uiEffects/ui_ty_zdbs_0101", "ui_ty_zdbs_0101", 295, 332.5);
			elseif templateId == 1004 then
				effect = UICreate.createUIEffect(self.towerObject_9, "/effects/uiEffects/ui_ty_zdbs_0101", "ui_ty_zdbs_0101", 280, 925.5);
			end
			if effect ~= nil then
				effect.anchorValue = 7;
			end
			self.effectDic[templateId] = effect;
		else
			effect:setEnable(true);
		end
	else
		if effect then
			effect:setEnable(false);
		end
	end
end

function Lua_ClimbTowerEntranceWindow:onClick(go)
	local arr = string.split(go.name, "_");
	local towerId = tonumber(arr[2]);
	local vo = DataCenter.climbTowerData:getTowerVoById(towerId);
	if not DataCenter.funcOpenData:isOpened(vo.func_id, true) then
		return;
	end

	if not vo.isOpened then
		OperateAlert.show(vo.open_str..vo.name);
		return;
	end
	
	-- local isFighting = DataCenter.fightData:checkFightingByTemplateId(vo.fight_id);
	-- if isFighting then
	-- 	DataCenter.fightData:showFightToStage(vo.fight_id);
	-- end
	-- Lua_WindowUtil.openWin(vo.windowName, Lua_WinParam.ACTION_OPEN, towerId);
	DataCenter.funcPathUtil:gotoFunction(vo.pathId);

	if not strIsNullOrEmpty(vo.loginId) then
		DataCenter.redPointData:updateRedPointState(vo.loginId, false, true)
	end
end