--奖励领取
Lua_ClimbTowerRewardWindow = class("Lua_ClimbTowerRewardWindow", Lua_Window);
function Lua_ClimbTowerRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ClimbTowerRewardWindow";
	self.skinName = "ClimbTowerRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ClimbTowerRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.campTowerIsOpen = DataCenter.climbTowerData:checkCampTowerIsOpen();
	local posY;
	local height;
	if self.campTowerIsOpen then
		self.bg_1:SetDimensions(655, 718);
		self.bg_2:SetDimensions(635, 697); -- 一键领取 614
		self.bg_3:setEnable(true);
		
		posY = 5;
		height = 680;

		self.buttonInfo = Array();
		local arr = DataCenter.climbTowerData.towerArr;
		local vo;
		for i = 1, arr:getSize() do
			vo = DataCenter.climbTowerData:getTowerVoById(arr[i]);
			self.buttonInfo:add(vo);
		end

		self.buttonList = Lua_DragList.new(self.content, 667, 70, Lua_AxisDefine.Horizontal);
		self.buttonList:setLocation(0, -397, 0);
		self.buttonList:setListCell(Lua_ClimbTowerRewardOptionsItem, 148, 70, 1);
		self.buttonList:setArrayData(self.buttonInfo);
	else
		self.bg_1:SetDimensions(655, 775);
		self.bg_2:SetDimensions(635, 754); -- 一键领取 647
		self.bg_3:setEnable(false);
		
		posY = -25;
		height = 735;
	end

	self.itemList = Lua_DragList.new(self.content, 625, height, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(0, posY, 0);
	self.itemList:setListCell(Lua_ClimbTowerRewardItem, 625, 180, 1);
	self.itemList:setCellSpacing(0, 5);

	self.btnReceive:addClickFuntion(self, self.onBtnReceiveClick);

	self:addLuaEvent("TWOER_OPTIONS_SELECT", self, self.updateShowInfo);
	self:addLuaEvent("UPDATE_TOWER_INFO", self, self.updateShowInfo);
end

function Lua_ClimbTowerRewardWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.buttonList ~= nil then
		self.buttonList:dispose();
		self.buttonList = nil;
	end
	if self.buttonInfo ~= nil then
		self.buttonInfo:clear();
		self.buttonInfo = nil;
	end
	self:superCall("dispose");
end

function Lua_ClimbTowerRewardWindow:showWin(param)
	self:superCall("showWin", param);
	local arr = DataCenter.climbTowerData.towerArr;
	if type(param) == "table" then
		param = arr:indexOf(param.main_id)
	end
	if self.buttonList == nil then
		self:updateShowInfo(arr[param]);
	else
		self.buttonList:moveToIndex(param, true);
		self.buttonList:setSelectClick(param);
		self.buttonList:setSelected(param);
	end
end

function Lua_ClimbTowerRewardWindow:updateShowInfo(towerId)
	self.towerId = towerId;

	local arr = DataCenter.climbTowerUtil:getRewardsInfoById(towerId);
	local receiveNum = 0;
	local state;
	for i = 1, arr:getSize() do
		state = DataCenter.climbTowerData:getStageRewardState(towerId, arr[i]);
		if state == 1 then
			receiveNum = receiveNum + 1;
		end
		if receiveNum > 1 then
			break;
		end
	end

	local posY;
	local height;
	if receiveNum > 1 then
		self.btnReceive:setEnable(true);
		if self.campTowerIsOpen then
			self.bg_2:SetDimensions(635, 614);
			self.btnReceive:setLocation(0, -310, 0);
			posY = 45;
			height = 599;
		else
			self.bg_2:SetDimensions(635, 647);
			self.btnReceive:setLocation(0, -354, 0);
			posY = 28;
			height = 626;
		end
	else
		self.btnReceive:setEnable(false);
		if self.campTowerIsOpen then
			self.bg_2:SetDimensions(635, 697);
			posY = 5;
			height = 680;
		else
			self.bg_2:SetDimensions(635, 754);
			posY = -25;
			height = 735;
		end
	end
	self.itemList:setLocation(0, posY, 0);
	self.itemList:setContentRect(625, height);
	self.itemList:setArrayData(arr);
	self.itemList:moveToIndex(1, true);
end

function Lua_ClimbTowerRewardWindow:onBtnReceiveClick(go)
	if self.towerId == nil then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_ClimbTowerProxy"):sReceiveTowerReward(self.towerId, 0);
end




















Lua_ClimbTowerRewardOptionsItem = class("Lua_ClimbTowerRewardOptionsItem", Lua_ListCell);
function Lua_ClimbTowerRewardOptionsItem:ctor(p)
    self:superCall("ctor", p, "ClimbTowerRewardOptionsItem_skin");
end

function Lua_ClimbTowerRewardOptionsItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_ClimbTowerRewardOptionsItem:dispose()
    if self.redPointIcon ~= nil then
        self.redPointIcon:dispose();
        self.redPointIcon = nil;
    end
    self.data = nil;
    self:superCall("dispose");
end

function Lua_ClimbTowerRewardOptionsItem:setData(data)
    self.data = data;
    if data == nil then
        return;
    end
    
    self.btnName.text = data.name;
    self:setRedPoint(data.redpointId);
end

function Lua_ClimbTowerRewardOptionsItem:setRedPoint(id)
	if strIsNullOrEmpty(id) then
		if self.redPointIcon ~= nil then
			self.redPointIcon:changeRedPoint(nil);
		end
	else
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content);
			self.redPointIcon:setLocation(50, 20);
		end
		self.redPointIcon:changeRedPoint(id);
	end
end

function Lua_ClimbTowerRewardOptionsItem:onSelectionChange(bSelect)
    self:superCall("onSelectionChange", bSelect);
    self.btnBg:setEnable(bSelect);
    if bSelect then
        self.btnName.colorStr = Lua_ColorDefine.transColorStr("8B5E34");
    else
        self.btnName.colorStr = Lua_ColorDefine.transColorStr("5C504B");
    end
end

function Lua_ClimbTowerRewardOptionsItem:onPressClick()
    if self.data == nil then
        return;
    end
    Lua_MsgUtil.callFunc("TWOER_OPTIONS_SELECT", self.data.id);
    return true;
end




















Lua_ClimbTowerRewardItem = class("Lua_ClimbTowerRewardItem", Lua_ListCell);
function Lua_ClimbTowerRewardItem:ctor(p)
	self:superCall("ctor", p, "ClimbTowerRewardItem_skin");
end

function Lua_ClimbTowerRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_ItemIconList.new(self.content);
	self.itemList:setLocation(-245, -18, 0);
	self.itemList.pivot = 1;
	self.itemList.scaleVal = 0.9;

	self.btnReceive:addClickFuntion(self, self.onBtnReceiveClick);
end

function Lua_ClimbTowerRewardItem:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ClimbTowerRewardItem:setData(data)
	self.rewardId = data;
	self.data = DataCenter.climbTowerUtil:getRewardConfig(data);
	if self.data == nil then
		return;
	end
	
	self.titleText.text = LanUtil.formateStr(201016, tostring(self.data.storey));
	self.itemList:setArrayData(self.data.reward);
	local vo = DataCenter.climbTowerData:getTowerVoById(self.data.index);
	local state = DataCenter.climbTowerData:getStageRewardState(self.data.index, data);
	local str;
	if state == 1 then
		str = Lua_ColorDefine.getColorStr("459252", self.data.storey);
		self.btnReceive:setEnable(true);
		self.stateIcon:setEnable(false);
	elseif state == 2 then
		str = Lua_ColorDefine.getColorStr("459252", self.data.storey);
		self.btnReceive:setEnable(false);
		self.stateIcon:setEnable(true);
		self.stateIcon:setAltas("common_altas_1", "ui_common_label_17");
	else
		str = Lua_ColorDefine.getColorStr("E01B1B", vo.cur_stage_storey - 1);
		self.btnReceive:setEnable(false);
		self.stateIcon:setEnable(true);
		self.stateIcon:setAltas("common_altas_2", "ui_common_label_27");
	end
	self.valueText.text = str.."/"..self.data.storey;
	self:showRedDot(state == 1);
end

function Lua_ClimbTowerRewardItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(270, 0, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_ClimbTowerRewardItem:onBtnReceiveClick(go)
	if self.data == nil then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_ClimbTowerProxy"):sReceiveTowerReward(self.data.index, self.rewardId);
end

function Lua_ClimbTowerRewardItem:onPressClick()
	self.itemList:onBoundClick();
end